/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalytics4ControllerActionDimensionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalytics4ControllerActionDimensionRequest{}

// GoogleAnalytics4ControllerActionDimensionRequest struct for GoogleAnalytics4ControllerActionDimensionRequest
type GoogleAnalytics4ControllerActionDimensionRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	PropertyId *string `json:"propertyId,omitempty"`
}

// NewGoogleAnalytics4ControllerActionDimensionRequest instantiates a new GoogleAnalytics4ControllerActionDimensionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalytics4ControllerActionDimensionRequest() *GoogleAnalytics4ControllerActionDimensionRequest {
	this := GoogleAnalytics4ControllerActionDimensionRequest{}
	return &this
}

// NewGoogleAnalytics4ControllerActionDimensionRequestWithDefaults instantiates a new GoogleAnalytics4ControllerActionDimensionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalytics4ControllerActionDimensionRequestWithDefaults() *GoogleAnalytics4ControllerActionDimensionRequest {
	this := GoogleAnalytics4ControllerActionDimensionRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetPropertyId returns the PropertyId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) GetPropertyId() string {
	if o == nil || IsNil(o.PropertyId) {
		var ret string
		return ret
	}
	return *o.PropertyId
}

// GetPropertyIdOk returns a tuple with the PropertyId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) GetPropertyIdOk() (*string, bool) {
	if o == nil || IsNil(o.PropertyId) {
		return nil, false
	}
	return o.PropertyId, true
}

// HasPropertyId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) HasPropertyId() bool {
	if o != nil && !IsNil(o.PropertyId) {
		return true
	}

	return false
}

// SetPropertyId gets a reference to the given string and assigns it to the PropertyId field.
func (o *GoogleAnalytics4ControllerActionDimensionRequest) SetPropertyId(v string) {
	o.PropertyId = &v
}

func (o GoogleAnalytics4ControllerActionDimensionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalytics4ControllerActionDimensionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.PropertyId) {
		toSerialize["propertyId"] = o.PropertyId
	}
	return toSerialize, nil
}

type NullableGoogleAnalytics4ControllerActionDimensionRequest struct {
	value *GoogleAnalytics4ControllerActionDimensionRequest
	isSet bool
}

func (v NullableGoogleAnalytics4ControllerActionDimensionRequest) Get() *GoogleAnalytics4ControllerActionDimensionRequest {
	return v.value
}

func (v *NullableGoogleAnalytics4ControllerActionDimensionRequest) Set(val *GoogleAnalytics4ControllerActionDimensionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalytics4ControllerActionDimensionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalytics4ControllerActionDimensionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalytics4ControllerActionDimensionRequest(val *GoogleAnalytics4ControllerActionDimensionRequest) *NullableGoogleAnalytics4ControllerActionDimensionRequest {
	return &NullableGoogleAnalytics4ControllerActionDimensionRequest{value: val, isSet: true}
}

func (v NullableGoogleAnalytics4ControllerActionDimensionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalytics4ControllerActionDimensionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
